FR.CusForm = FR.extend(FR.Form, {
    /**
     * 上传到服务器
     * @param {JSON} o 配置属性
     * @param {JSON} target 目标对象
     */
    serverCommit: function (o, target) {
        var self = this;
        if (_g().saveReport) {
            _g().saveReport((function () {
                this.formSubmit({
                    url: FR.servletURL + "?op=customcommit",
                    data: {
                        cmd: o.cmd,
                        location: target
                            ? target.options.location
                            : null,
                        sheetNum: _g().selectedIndex,
                        xmlconf: o.xmlconf,
                        sessionID: _g().currentSessionID || _g().sessionID
                    },
                    callback: function (res) {
                        self.showResult(res);
                    }
                });
            }).createDelegate(this));
        } else {
            this.formSubmit({
                url: FR.servletURL + "?op=customcommit",
                data: {
                    xmlconf: o.xmlconf,
                    cmd: o.cmd,
                    sessionID: _g().currentSessionID || _g().sessionID

                },
                callback: function (res) {
                    self.showResult(res);
                }
            });
        }
    },
    showResult: function (res) {
        var submitInfo;
        var json_array = FR.jsonDecode(res.responseText);
        if (json_array.length > 0) {
            $.each(json_array, function (idx, item) {
                if (item.fr_submitinfo) {
                    submitInfo = item.fr_submitinfo;
                }
            });
        }
        var success = submitInfo.success;
        if (success !== true && success !== false) {
            FR.Msg.toast(FR.i18nText("FR-Engine_Report") + FR.i18nText("FR-Engine-Report-Write_Attributes_Msg"));
        } else if (success === true) {
            FR.Msg.toast(FR.i18nText("FR-Engine_Successfully"));
        } else if (success === false) {
            FR.Msg.toast(FR.i18nText("FR-Engine_Failed") + ":" + submitInfo.failinfo);
        }
    }
});
$.extend(FR, {
    doHyperlinkByDownload: function (path, encode) {
        if (arguments.length < 1) {
            return;
        }
        var options = arguments[0];
        if (typeof options === 'object') {
            path = options.path || '';
            encode = options.encode || '';
        }
        this.ajax({
            url: FR.servletURL + '?op=customcommit&cmd=checkfile',
            async: true,
            data: {
                path: encodeURIComponent(path),
                sessionID: FR.SessionMgr.getSessionID()
            },
            type: 'post',
            complete: function (res, status) {
                var o = FR.jsonDecode(res.responseText);
                if (o.path) {
                    window.location = FR.servletURL + "?op=customcommit&cmd=downloadfile&path=" + o.path + "&encode=" + encode;
                } else {
                    FR.Msg.toast(FR.i18nText('FR-Designer_Msg_Wrong_Path'));
                }
            }.createDelegate(this)
        });
    }
});